
/////////////////////////////
//Initial function for HUD//
///////////////////////////

float sep = 25;
float constantHorizontalMargin = 160;
float constantVerticalMargin = 100;
float massbar=400;


String speedmessage, agemessage;

void fixedDisplay() {
  perspective();
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  
  textSize(18);

  agemessage = "Age in Myr: \n" + (float)star_age[(int)printage]/1000000;

  stroke(255);
  strokeWeight(2);
  line(50, height-60, width-50, height-60);
  fill(255);
  ellipse(map((float)star_age[(int)age], 0, (float)max_age, 50, width-50), height-60, 10, 10);
  fill(255, 0, 0);
  stroke(255, 0, 0);
  ellipse(map(4.5e9, 0, (float)max_age, 50, width-50), height-60, 10, 10);
  text("Sun's Age", map(4.5e9, 0, (float)max_age, 50, width-50)+20, height-80);
  fill(255);
  text(agemessage, map((float)star_age[(int)age], 0, (float)max_age, 50, width-50)+50, height-100);
  stroke(0);

  textAlign(RIGHT);


  burnColor = lerpColor(minburncolor, maxburncolor, (float)((burn_h[(int)age]-min_h_burn)/(max_h_burn-min_h_burn)));
  fill(burnColor);
  rect(width-70-h1_mass[(int)age]*massbar, 100, massbar*(h1_mass[(int)age]), 50);
  fill(255);
  stroke(255);
  textSize(12);
  line(width-70, 150, width-70, 155);
  text("0.0", width-60-0.0*massbar, 165);
  line(width-70-0.2*massbar, 150, width-70-0.2*massbar, 155);
  text("0.2", width-60-0.2*massbar, 165);
  line(width-70-0.4*massbar, 150, width-70-0.4*massbar, 155);
  text("0.4", width-60-0.4*massbar, 165);
  line(width-70-0.6*massbar, 150, width-70-0.6*massbar, 155);
  text("0.6", width-60-0.6*massbar, 165);
  line(width-70-0.8*massbar, 150, width-70-0.8*massbar, 155);
  text("0.8", width-60-0.8*massbar, 165);
  text("M_sun", width-60-0.0*massbar, 175);
  textSize(20);
  text("1 H", width-20, 130);

  stroke(0);
  burnColor = lerpColor(minburncolor, maxburncolor, (float)((burn_he[(int)age]-min_h_burn)/(max_h_burn-min_h_burn)));
  fill(burnColor);
  rect(width-70-he4_mass[(int)age]*massbar, 200, massbar*(he4_mass[(int)age]), 50);
  fill(255);
  stroke(255);
  textSize(12);
  line(width-70, 250, width-70, 255);
  text("0.0", width-60-0.0*massbar, 265);
  line(width-70-0.1*massbar, 250, width-70-0.1*massbar, 255);
  text("0.1", width-60-0.1*massbar, 265);
  line(width-70-0.2*massbar, 250, width-70-0.2*massbar, 255);
  text("0.2", width-60-0.2*massbar, 265);
  line(width-70-0.3*massbar, 250, width-70-0.3*massbar, 255);
  text("0.3", width-60-0.3*massbar, 265);
  line(width-70-0.4*massbar, 250, width-70-0.4*massbar, 255);
  text("0.4", width-60-0.4*massbar, 265);
  text("M_sun", width-60-0.0*massbar, 275);
  textSize(20);
  text("4 He", width-20, 230);


  stroke(0);
  burnColor = minburncolor;
  fill(burnColor);
  rect(width-70-c12_mass[(int)age]*massbar, 300, massbar*(c12_mass[(int)age]), 50);
  fill(255);
  stroke(255);
  textSize(12);
  line(width-70, 350, width-70, 355);
  text("0.0", width-60-0.0*massbar, 365);
  line(width-70-0.1*massbar, 350, width-70-0.1*massbar, 355);
  text("0.1", width-60-0.1*massbar, 365);
  line(width-70-0.2*massbar, 350, width-70-0.2*massbar, 355);
  text("0.2", width-60-0.2*massbar, 365);
  line(width-70-0.3*massbar, 350, width-70-0.3*massbar, 355);
  text("0.3", width-60-0.3*massbar, 365);
  line(width-70-0.4*massbar, 350, width-70-0.4*massbar, 355);
  text("0.4", width-60-0.4*massbar, 365);
  text("M_sun", width-60-0.0*massbar, 375);
  textSize(20);
  text("12 C", width-20, 330);


  stroke(0);
  burnColor = minburncolor;
  fill(burnColor);
  rect(width-70-o16_mass[(int)age]*massbar, 400, massbar*(o16_mass[(int)age]), 50);
  fill(255);
  stroke(255);
  textSize(12);
  line(width-70, 450, width-70, 455);
  text("0.0", width-60-0.0*massbar, 465);
  line(width-70-0.1*massbar, 450, width-70-0.1*massbar, 455);
  text("0.1", width-60-0.1*massbar, 465);
  line(width-70-0.2*massbar, 450, width-70-0.2*massbar, 455);
  text("0.2", width-60-0.2*massbar, 465);
  line(width-70-0.3*massbar, 450, width-70-0.3*massbar, 455);
  text("0.3", width-60-0.3*massbar, 465);
  line(width-70-0.4*massbar, 450, width-70-0.4*massbar, 455);
  text("0.4", width-60-0.4*massbar, 465);
  text("M_sun", width-60-0.0*massbar, 475);
  textSize(20);
  text("16 O", width-20, 430);



  fill(255);
  textAlign(LEFT);
  textSize(30);


  textSize(16);
  textAlign(RIGHT);
  fill(255);
  fill(convection);
  rect(10, 80, 20, 20);
  text("convective mixing", 180, 95);
  fill(minburncolor);
  rect(10, 110, 20, 20);
  text("weak burning", 150, 125);
  fill(maxburncolor);
  rect(10, 140, 20, 20);
  text("strong burning", 160, 155);
  fill(cooling);
  rect(10, 170, 20, 20);
  text("cooling", 100, 185);
  
  fill(0);
  rect(10, 200, 20, 20);
  fill(255);
  rect(40, 200, 100, 20);
  fill(0);
  text("weak wind", 130, 215);
  fill(255);
  rect(10, 230, 20, 20);
  text("strong wind", 140, 245);
  fill(255);
  text("Jared Brooks, Final Project - MAT259", width-20, height-25);

  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}